
   NAME
	BigAnim - Displays IFF animations

   SYNOPSIS
	Usage: BigAnim filename [LOADALL] [HIRES] [BLANK] [VERBOSE]
	                        [BUFSIZE n] [RELTIME n] [TASKPRI n]

   DESCRIPTION
	BigAnim displays IFF ANIM animations, types 5 and 7. Normally (if
	the switch LOADALL is not used), BigAnim loads the animation using a
	double-buffering method, so that the frames in the first buffer are
	being displayed while the second buffer is being filled. The default
	buffer size is 100 KBytes, and it can be set with the option BUFSIZE.

	On pre-V39 systems, BigAnim takes over the display from intuition,
	but only when BigAnim's screen is the frontmost one, and if it hasn't
	been dragged down. This means that you can flip screens or pull down
	BigAnim's screen at any time, but when you do this, BigAnim will be
	forced to use a slower, intuition-friendly display method.

	On systems running V39 (or later), BigAnim will use new the double-
	buffering routines in graphics.library.

   OPTIONS
	LOADALL	    Tells BigAnim to load the whole animation before
		    starting playback.

	HIRES	    Forces the screen resolution to Highres/Interlace.

	BLANK	    Blanks the mouse pointer.

	VERBOSE	    BigAnim prints some info about the animation, such as
		    screen size/depth, display modes and animation type.

	BUFSIZE n   Sets the buffer size to n bytes. The default is 102400
		    (100 KBytes). If LOADALL is used, the animation will
		    will be loaded in chunks of n bytes. If LOADALL isn't
		    used, BigAnim will need two buffers of n bytes for the
		    double-buffering loading method. Note: If the entire
		    animation can be loaded in those two buffers, BigAnim
		    will behave as though LOADALL was used.

	RELTIME n   Sets the playback timing, in 1/50 seconds if you're
		    running on a PAL system, or 1/60 for NTSC systems.

	TASKPRI n   This sets BigAnim's task priority during playback.
		    If your hard disk controller doesn't use DMA, the
		    playback will probably be less jerky if you use a
		    high task priority.

   KEYS
	ESC	    Quits BigAnim (you can also use the right mouse button)

	Space	    Pauses the animation, or restarts if already paused

	N	    If paused, displays the next frame

	0-9	    Changes playback speed. By pressing one of the keys
	F1-F10	    1-9 or F1-F9 you can directly set the RELTIME value.
		    If you press 0 or F10, BigAnim will use the timing
		    information stored in the animation.

   ENVIRONMENT
	BIGANIMOPTS	Set this to whatever options you want to use as
			default. All options except LOADALL can be used.

   AUTHOR
	Christer Sundin (d8sunch@dtek.chalmers.se)

