/*********************************/
/* Image Engineer Macro script   */
/* by Simon Edwards              */
/* 3/6/95                        */
/*                               */
/* This creates a sort of motion */
/* blur effect.                  */
/*********************************/

Options results
signal on error			/* Setup a place for errors to go */

if arg()==0 then exit

'REQUEST "Direction to Motion Blur in" "Horizontal|Vertical"'
reply=RESULT

if reply=1 then
	do
	xoffset=1
	yoffset=0
	end
else
	do
	xoffset=0
	yoffset=1
	end

'REQUEST "Number of pixels to blur by" "1|2|4|8|16"'
reply=RESULT

select
	when reply=1 then times=0
	when reply=2 then times=1
	when reply=3 then times=2
	when reply=4 then times=3
	when reply=0 then times=4
end

MARK arg(1) PRIMARY
MARK arg(1) SECONDARY
COMPOSITE xoffset yoffset Max
temp=RESULT

xoffset=xoffset*2
yoffset=yoffset*2

do while times~=0
	MARK temp PRIMARY
	MARK temp SECONDARY
	COMPOSITE xoffset yoffset Max
	temp2=RESULT
	CLOSE temp
	temp=temp2
	xoffset=xoffset*2
	yoffset=yoffset*2
	times=times-1
end

exit

/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
