/**************************************************/
/* Image Engineer script                          */
/* by Simon Edwards                               */
/* Applies a blurred Vignette effect to an image. */
/**************************************************/

Options results
signal on error			/* Setup a place for errors to go */

if arg()==0 then exit

LOWPASS arg(1) 7 7
blurredimage=result
PROJECT_INFO arg(1) Width
width=result
PROJECT_INFO arg(1) Height
height=result

TYPE 8BIT
'OPEN IE:alpha/Spherical.alpha'
alphachannel=result
SCALE alphachannel width height BEST
newalpha=result
CLOSE alphachannel

MARK arg(1) PRIMARY
MARK blurredimage SECONDARY
MARK newalpha ALPHA
COMPOSITE 0 0 ALPHA

CLOSE newalpha
CLOSE blurredimage

exit

/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
